//
// Created by hbini on 4/15/24.
//

#ifndef ACL_RESNET50_FCOS_PARAMETERS_H
#define ACL_RESNET50_FCOS_PARAMETERS_H

#endif //ACL_RESNET50_FCOS_PARAMETERS_H

/*
 * Copyright (C) 2024 by Leon.
 * Created by Leon
 */
#pragma once

#include <string>
#include <utility>
#include <vector>
#include <array>
#include "Utils_eigne.h"

struct Fcos3dInitParams {
    std::string config_file;

//    std::string model_file;
    Fcos3dInitParams(std::string config_file) {
        this->config_file = std::move(config_file);
    }
};

class Fcos3dConstantParameter {
public:
    std::array<uint32_t, 2> fpn0_size;
    std::array<uint32_t, 2> fpn1_size;
    std::array<uint32_t, 2> fpn2_size;
    std::array<uint32_t, 2> fpn3_size;
    std::array<uint32_t, 2> fpn4_size;
    uint32_t num_cls;
    uint32_t num_bbox;
    uint32_t num_dir_cls;
    uint32_t num_arrt;
    int num_attrs ;
    int nms_pre ;
    int cls_out_channels ;
    uint32_t num_centerness;
    std::array<float, 3> mean;
    std::array<float, 3> std_dev;
    std::string om_model_path;
    std::string input_folder;
    std::string output_folder;
    Vec<int> strides;
    Vec<int> group_reg_dims;
    Vec<float> origin ;
    Vec<float> origin_defualt ;
    Vec<float> scale_factor ;

    int height ;
    int width ;
    int channel;
    int num_threads ;

    float dir_offset;
    float cfg_score_thr ;
    int cfg_max_per_img ;
    bool cfg_use_rotate_nms;
    float cfg_nms_thr ;
    Vec2D<float> nuscenes_cam_back_cam2img;

};

template<typename T>
class Fcos3dPostProcessParameter {
public:
    Vec<int> strides;
    int nms_pre;
    float dir_offset ;
    float cfg_score_thr ;
    int cfg_max_per_img ;
    float cfg_nms_thr ;

    int cls_out_channels;
    int num_attrs;
    Vec<int> group_reg_dims;
//    bool cfg_use_rotate_nms = true;
    Vec<T> origin ;
    Vec<T> origin_defualt ;
    Vec<T> scale_factor ;
    Vec2D<T> nuscenes_cam_back_cam2img ;


};

template<typename T>
class Fcos3dPreProcessParameter {
public:
    std::array<float, 3> mean;
    std::array<float, 3> std_dev;
    int height ;
    int width ;
    int channel ;
    int num_threads ;
};